%global momorel 1

Summary:        Read a preset list of files into memory.
Name:           readahead
Version:        1.3
Release:	%{momorel}m
Group:          System Environment/Base
License:        GPL
Source0:	readahead.c
Source2:	readahead-check
Source4:	readahead_early
Source5:	readahead_later
Source6:	default.early.in
Source7:	default.later.in
Source8:	COPYING
Source9:	README
Buildroot:      %{_tmppath}/%{name}-%{version}-root

Requires(post):	chkconfig
Requires(pre): 	chkconfig
Requires(triggerpostun): chkconfig
Requires:	procps gawk

BuildPreReq:	e2fsprogs-devel
BuildRequires:	pkgconfig

Obsoletes:	kernel-utils

%description
readahead reads the contents of a list of files into memory,
which causes them to be read from cache when they are actually
needed. Its goal is to speed up the boot process.

%prep

%build
rm -rf $RPM_BUILD_ROOT

mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}/sbin
mkdir -p %{buildroot}/etc/rc.d/init.d
mkdir -p %{buildroot}/etc/readahead.d
gcc $RPM_OPT_FLAGS %{SOURCE0} -o readahead `pkg-config --libs ext2fs blkid`

for file in %{SOURCE6} %{SOURCE7} ; do
  f=${file##*/}
  sed 's|%%{_lib}|%{_lib}|g; s|%%{_arch}|%{_arch}|g' $file > ${f%%.in}
done

%install
# readahead binary
install -m 755 readahead %{buildroot}%{_sbindir}
# init scripts
install %{SOURCE4} %{buildroot}/etc/rc.d/init.d
install %{SOURCE5} %{buildroot}/etc/rc.d/init.d
# lists
install default.early %{buildroot}/etc/readahead.d/
install default.later %{buildroot}/etc/readahead.d/
# docs
[ "$RPM_SOURCE_DIR" != $(pwd) ] && cp %{SOURCE2} %{SOURCE8} %{SOURCE9} .

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;
rm -f default.early default.later

%files
%defattr(-,root,root)
%doc COPYING README readahead-check
%attr(0644,root,root) %{_sysconfdir}/readahead.d/default.early
%attr(0644,root,root) %{_sysconfdir}/readahead.d/default.later
%{_sbindir}/readahead
%{_sysconfdir}/rc.d/init.d/readahead_later
%{_sysconfdir}/rc.d/init.d/readahead_early

%preun
if [ "$1" = "0" ] ; then
 /sbin/chkconfig --del readahead_later
 /sbin/chkconfig --del readahead_early
fi

%post
/sbin/chkconfig --add readahead_later
/sbin/chkconfig --add readahead_early

%triggerpostun -- kernel-utils
/sbin/chkconfig --add readahead_later
/sbin/chkconfig --add readahead_early
exit 0


%changelog
* Sat Aug 12 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.3-1m)
- import from fc

* Sat May 20 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.2-1m)
- import from fc

* Fri Jan 13 2006 Karel Zak <kzak@redhat.com>
- check & cleanup list of files by readahead-gen script

* Wed Dec 21 2005 Karel Zak <kzak@redhat.com>
- removed double slashes in the directory names
- removed or fixed the rest of X11R6 directories

* Mon Dec 19 2005 Karel Zak <kzak@redhat.com>
- sync versioned gcc, firefox, openoffice.org, evolution dirs with FC5

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Thu Aug  4 2005 Dave Jones <davej@redhat.com>
- Integrated changes from Ville Skyttä (#164872)
  - Fix inverted logic in readahead_early also.
  - readahead_early looks useful in more runlevels than just 5.
  - Sync versioned gcc, firefox and openoffice.org dirs with FC4 updates.

* Tue Aug  2 2005 Dave Jones <davej@redhat.com>
- Fix inverted free memory test in startup script. (#164872)

* Wed May 18 2005 Bill Nottingham <notting@redhat.com>
- new readahead.c from Ziga Mahkovec <ziga.mahkovec@klika.si>
  - optimizes read access for more throughput
- regenerate file lists (#128444)
- fix lack of newlines (#146744)
- fix lists so that they are architecture-neutral
- move check for > 384MB into the init scripts, not the %%post

* Tue Mar  1 2005 Dave Jones <davej@redhat.com>
- Rebuild for gcc4

* Thu Feb 10 2005 Dave Jones <davej@redhat.com>
- Remove non-existent files from file lists.

* Fri Jan 14 2005 Dave Jones <davej@redhat.com>
- Don't do readahead if we have less than 256MB of memory.

* Sat Dec 18 2004 Dave Jones <davej@redhat.com>
- Initial packaging, based upon kernel-utils.

